package nckd.jimin.jyyy.fi.plugin.operate;

import kd.bos.entity.plugin.AbstractOperationServicePlugIn;
import kd.bos.entity.plugin.args.BeforeOperationArgs;
import kd.sdk.plugin.Plugin;
import nckd.jimin.jyyy.fi.mservice.impl.SynSapFIServiceImpl;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * 单据操作插件
 */
public class SynVoucherSapOpPlugin extends AbstractOperationServicePlugIn implements Plugin {
    @Override
    public void beforeExecuteOperationTransaction(BeforeOperationArgs e) {
        //获取列表中选择的单据内码
        List<Long> billids = (List) Arrays.asList(e.getDataEntities()).stream().map((entityx) -> {
            return entityx.getLong("id");
        }).collect(Collectors.toList());

        SynSapFIServiceImpl synSapService = new SynSapFIServiceImpl();

        Map<String, String> result=synSapService.synVoucherForSap(billids);
        System.out.println(result.get("msg"));
        this.getOperationResult().setSuccess(false); // 操作失败
        this.operationResult.setMessage(result.get("msg"));
    }
}